/*
 * Part of the PiyoPiyoJ project.
 * (PiyoPiyo Java)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */

package piyopiyoj.games.edittools;

import gabien.music.PiyoPiyoFrame;
import piyopiyoj.games.NotesheetGame;

public class NoteEditTool implements EditTool {

    @Override
    public void onClick(int frameIndex, int pos, int button, NotesheetGame editor) {
        if (button == 1) {
            PiyoPiyoFrame frame = editor.root.coreFile.musicFrames[frameIndex + ((editor.root.coreFile.musicFrames.length / 4) * editor.noteDisplay.track)];
            frame.hitNotes[pos] = !frame.hitNotes[pos];
            if (!editor.root.playerControls.playing)
                editor.root.corePlayer.playNote(editor.noteDisplay.track, pos, 3);
        }
    }

    @Override
    public void onDrag(int frameIndex, int pos, NotesheetGame editor) {

    }

    @Override
    public String[] toolOpened() {
        String[] info = new String[] {
                "Note Editor",
                "Click to change notes on the notesheet.",
                "",
                ""
        };
        return info;
    }

}
